SystemOrganization addCategory: #'Mendel-Model'!

!String methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/15/2012 15:36'!
splitCamelCase
	| result currentString |
	result := OrderedCollection new.
	currentString := WriteStream on:(String new).
	self doWithIndex:[:char :idx |
		(char isUppercase and:[idx > 1]) 
			ifTrue:[
				result add: (currentString contents).
				currentString := WriteStream on:(String new).
				currentString nextPut: char]
			ifFalse:[
				currentString nextPut: char]].
	"Do not forget the last token"
	result add: (currentString contents).
	^result 
	! !

!CompiledMethod methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/18/2012 10:28'!
mendelAddCallsTo: aSet
	self messages
		do: [ :message | 
			aSet add:(CallsTrait value: message)]! !

!CompiledMethod methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/18/2012 10:12'!
mendelAddImplementsMessagesTo: aSet
	aSet add:(ImplementsMessageTrait value: self selector)	! !

!CompiledMethod methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/18/2012 10:19'!
mendelAddInProtocolTo: aSet
	aSet add:(InProtocolTrait value: (self category))! !

!CompiledMethod methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/19/2012 16:12'!
mendelAddKeywordsTo: aSet
		(self selector asString splitCamelCase)
			do: [:keyword | 
				(keyword size >= 4) 
					ifTrue: [aSet add: (KeywordTrait value: keyword)]]! !

!CompiledMethod methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/19/2012 16:21'!
mendelAddRefersClassesTo: aSet
	self literals
		do: [ :literal | 
			(literal isKindOf: Association)
				ifTrue: [ 
					(literal value isKindOf: ClassDescription)
						ifTrue: [ 
							(literal value ~= self methodClass)
								ifTrue: [ aSet add: (RefersClassTrait value: literal value) ] ] ] ]! !

!CompiledMethod methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/21/2012 17:30'!
mendelRecommendations
	^(Genotype forEntity: self) recommendations! !

!CompiledMethod methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/18/2012 10:29'!
mendelTraits
	| theTraits |
	theTraits := Set new.
	self mendelAddKeywordsTo: theTraits.
	self mendelAddImplementsMessagesTo: theTraits.
	self mendelAddInProtocolTo: theTraits.
	self mendelAddRefersClassesTo: theTraits.
	self mendelAddCallsTo: theTraits.
	^theTraits! !

Object subclass: #AbstractEntityTrait
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!AbstractEntityTrait class methodsFor: 'instance creation' stamp: 'AndyKellens 6/15/2012 14:40'!
value: aValue 
	^super new value: aValue! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/15/2012 14:41'!
= anEntityTrait
	^self class = anEntityTrait class and:[value = (anEntityTrait value)]! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/15/2012 14:41'!
hash 
	^value hash! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:56'!
isCallsTrait
	^false! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:56'!
isHierarchyTrait
	^false! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:56'!
isImplementsTrait
	^false! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:56'!
isKeywordTrait
	^false! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:56'!
isProtocolTrait
	^false! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isRefersClassTrait
	^false! !

!AbstractEntityTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isUnderstandsTrait
	^false! !

!AbstractEntityTrait methodsFor: 'printing' stamp: 'AndyKellens 6/15/2012 15:42'!
printOn: aStream
	aStream nextPutAll: (self traitName).
	aStream nextPutAll: '>>'.
	value printOn: aStream! !

!AbstractEntityTrait methodsFor: 'private' stamp: 'AndyKellens 6/15/2012 14:42'!
traitName
	self subclassResponsibility ! !

!AbstractEntityTrait methodsFor: 'accessing' stamp: 'AndyKellens 6/15/2012 14:40'!
value 
	^value! !

!AbstractEntityTrait methodsFor: 'accessing' stamp: 'AndyKellens 6/15/2012 14:40'!
value: aValue 
	value := aValue! !

AbstractEntityTrait subclass: #CallsTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!CallsTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isCallsTrait 
	^true! !

!CallsTrait methodsFor: 'private' stamp: 'AndyKellens 6/18/2012 10:22'!
traitName
	^'Calls'! !

AbstractEntityTrait subclass: #ImplementsMessageTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!ImplementsMessageTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isImplementsTrait 
	^true! !

!ImplementsMessageTrait methodsFor: 'private' stamp: 'AndyKellens 6/15/2012 14:51'!
traitName
	^'Implements'! !

AbstractEntityTrait subclass: #InHierarchyTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!InHierarchyTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isHierarchyTrait 
	^true! !

!InHierarchyTrait methodsFor: 'private' stamp: 'AndyKellens 6/15/2012 14:52'!
traitName
	^'Hierarchy'! !

AbstractEntityTrait subclass: #InProtocolTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!InProtocolTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isProtocolTrait 
	^true! !

!InProtocolTrait methodsFor: 'private' stamp: 'AndyKellens 6/18/2012 10:18'!
traitName
	^'Protocol'! !

AbstractEntityTrait subclass: #KeywordTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!KeywordTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:57'!
isKeywordTrait 
	^true! !

!KeywordTrait methodsFor: 'private' stamp: 'AndyKellens 6/15/2012 14:45'!
traitName
	^'Keyword'! !

AbstractEntityTrait subclass: #RefersClassTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!RefersClassTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:58'!
isRefersClassTrait 
	^true! !

!RefersClassTrait methodsFor: 'private' stamp: 'AndyKellens 6/15/2012 14:52'!
traitName
	^'Refers'! !

AbstractEntityTrait subclass: #UnderstandsMessageTrait
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!UnderstandsMessageTrait methodsFor: 'testing' stamp: 'AndyKellens 6/18/2012 12:58'!
isUnderstandsTrait 
	^true! !

!UnderstandsMessageTrait methodsFor: 'private' stamp: 'AndyKellens 6/15/2012 14:52'!
traitName
	^'Understands'! !

Object subclass: #Genotype
	instanceVariableNames: 'entity familyMembers familyTraits dominantTraits recessiveTraits'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!Genotype class methodsFor: 'instance creation' stamp: 'AndyKellens 6/20/2012 12:59'!
forEntity: anEntity
	^super new initializeWithEntity: anEntity! !

!Genotype methodsFor: 'private' stamp: 'AndyKellens 6/20/2012 14:14'!
calculateDominantTraits
	"All traits that are shared by familySize - familySize log: 4 familyMembers are considered to be dominant"
	 | result threshold |
	result := Set new.
	threshold := familyMembers size - (familyMembers size log: 4).
	familyTraits keysAndValuesDo: [:trait :membersWithTrait |
		(membersWithTrait size >= threshold) ifTrue:[result add: trait]].
	^result! !

!Genotype methodsFor: 'private' stamp: 'AndyKellens 6/20/2012 13:26'!
calculateFamilyTraits
	| traits |
	traits := Dictionary new.
	familyMembers do:[:familyMember |
		familyMember mendelTraits do:[:trait |
			(traits at: trait ifAbsentPut:[Set new]) add: familyMember]].
	^traits! !

!Genotype methodsFor: 'private' stamp: 'AndyKellens 6/20/2012 15:08'!
calculateRecessiveTraits
	"All non-dominant traits that are shared by familySize / 1.5 familyMembers are considered to be recessive"
	 | result threshold |
	result := Set new.
	threshold := (familyMembers size  / 1.5) floor.
	familyTraits keysAndValuesDo: [:trait :membersWithTrait |
		(membersWithTrait size >= threshold) ifTrue:[result add: trait]].
	^result copyWithoutAll: dominantTraits! !

!Genotype methodsFor: 'accessing' stamp: 'AndyKellens 6/20/2012 14:22'!
dominantTraits 
	^dominantTraits ! !

!Genotype methodsFor: 'accessing' stamp: 'AndyKellens 6/20/2012 13:32'!
entity 
	^entity! !

!Genotype methodsFor: 'accessing' stamp: 'AndyKellens 6/20/2012 13:32'!
familyMembers 
	^familyMembers 
	! !

!Genotype methodsFor: 'accessing' stamp: 'AndyKellens 6/20/2012 13:32'!
familyTraits
	^familyTraits! !

!Genotype methodsFor: 'initialize-release' stamp: 'AndyKellens 6/20/2012 14:33'!
initializeWithEntity: anEntity
	entity := anEntity.
	familyMembers := (anEntity mendelFamily).
	familyTraits := self calculateFamilyTraits.
	dominantTraits := self calculateDominantTraits.
	recessiveTraits := self calculateRecessiveTraits! !

!Genotype methodsFor: 'accessing' stamp: 'AndyKellens 6/20/2012 14:34'!
recessiveTraits
	^recessiveTraits ! !

!Genotype methodsFor: 'accessing' stamp: 'AndyKellens 6/21/2012 17:27'!
recommendations
	^MendelRecommendation fromGenotype: self! !

Object subclass: #MendelRecommendation
	instanceVariableNames: 'entity entityTraits suggested missing'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Mendel-Model'!

!MendelRecommendation class methodsFor: 'instance creation' stamp: 'AndyKellens 6/21/2012 17:13'!
fromGenotype: aGenotype
	^super new initializeWithGenotype: aGenotype! !

!MendelRecommendation methodsFor: 'accessing' stamp: 'AndyKellens 6/21/2012 17:14'!
entity 
	^entity! !

!MendelRecommendation methodsFor: 'accessing' stamp: 'AndyKellens 6/21/2012 17:14'!
entityTraits
	^entityTraits! !

!MendelRecommendation methodsFor: 'initialize-release' stamp: 'AndyKellens 6/21/2012 17:14'!
initializeWithGenotype: aGenotype
	entity := aGenotype entity.
	entityTraits := aGenotype entity mendelTraits.
	missing := aGenotype dominantTraits copyWithoutAll: entityTraits.
	suggested := aGenotype recessiveTraits copyWithoutAll: entityTraits! !

!MendelRecommendation methodsFor: 'accessing' stamp: 'AndyKellens 6/21/2012 17:15'!
missing
	^missing! !

!MendelRecommendation methodsFor: 'accessing' stamp: 'AndyKellens 6/21/2012 17:15'!
suggested
	^suggested ! !

!ClassDescription methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/15/2012 15:39'!
mendelAddImplementsMessagesTo: aSet
	self selectors do:[:selector | aSet add:(ImplementsMessageTrait value: selector)]! !

!ClassDescription methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/18/2012 13:40'!
mendelAddInHierarchyTo: aSet
	| superclasses |
	superclasses := self allSuperclasses copyWithoutAll: {Object . ProtoObject}.
	aSet add:(InHierarchyTrait value: self).
	superclasses do: [:theSuperClass | aSet add:(InHierarchyTrait value: theSuperClass)]! !

!ClassDescription methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/15/2012 15:36'!
mendelAddKeywordsTo: aSet
		(self name asString splitCamelCase)
			do: [:keyword | 
				(keyword size > 3) 
					ifTrue: [aSet add: (KeywordTrait value: keyword)]]! !

!ClassDescription methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/21/2012 17:34'!
mendelAddUnderstandsMessagesTo: aSet
	| superclasses  |

	superclasses := self allSuperclasses copyWithoutAll: {Object . ProtoObject}.
	superclasses add: self.
	superclasses
		do: [:each | each selectors do: [:selector | aSet add: (UnderstandsMessageTrait value: selector)]]! !

!ClassDescription methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/19/2012 16:37'!
mendelFamily
	"The family of the class are all my siblings and their subclasses"
	"If the class is abstract, then only consider abstract classes"
	"Classes without methods are considered to be concrete"
	| theFamily isAbstract |
	theFamily := Set new.
	isAbstract := self selectors ifEmpty: [false] ifNotEmpty:[self isAbstractClass].
	(self superclass ~= Object) 
		ifTrue:[
			| siblings |
			siblings := self superclass subclasses copyWithout: self.
			theFamily addAll:siblings.
			siblings do:[:sibling | theFamily addAll: (sibling subclasses)]].
	^theFamily select:[:each | each isAbstractClass = isAbstract]! !

!ClassDescription methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/21/2012 17:30'!
mendelRecommendations
	^(Genotype forEntity: self) recommendations! !

!ClassDescription methodsFor: '*Mendel-Model' stamp: 'AndyKellens 6/18/2012 10:07'!
mendelTraits
	| theTraits |
	theTraits := Set new.
	self mendelAddKeywordsTo: theTraits.
	self mendelAddImplementsMessagesTo: theTraits.
	self mendelAddUnderstandsMessagesTo: theTraits.
	self mendelAddInHierarchyTo: theTraits.
	^theTraits! !
